autowatch = 1;
outlets = 2;
var pMoves;
var succesMoves;
var localize = jsarguments;
//post(localize[1])

function translate(move, dtoe) {
	if (localize.length > 1 && localize[1] == "german") {
		var tr = [
			["B", "L"],
			["N", "S"],
			["R", "T"],
			["Q", "D"]
		];
		for (var i = 0; i < tr.length; i++) {
			if (dtoe) move = move.replace(tr[i][1], tr[i][0]);
			else move = move.replace(tr[i][0], tr[i][1]);
		}
	}
	return move;
}

function feedback(m) {
	//post("\nuci: ", m);
	m = m.toString();
	var result = m.split(" ");
	if (result[3] == "1") {
		var moveNum = result[2] % 2 != 0 ? ((parseInt(result[2]) + 1) / 2) + "." : "";
		succesMoves.push(moveNum + translate(result[0], false));
		outlet(0, "error", "");
		outlet(0, "lastMove", translate(result[0], false));
	} else {
		post("error", result.join("-"));
		outlet(0, "error", m);
		return;
	}
	if (pMoves.length == 0) {
		outlet(1, "clear");
		outlet(1, "set", succesMoves);
		return;
	}
	doNextMove();
}

function moves(m) {
	//post("\nraw\n", m);
	succesMoves = [];
	pMoves = parseMoves(m);
	//post("\nparsed\n", pMoves.join(" - "))
	outlet(0, "error", "");
	outlet(0, "reset");
	outlet(0, "flip", pMoves.length % 2);
	doNextMove();
}

function parseMoves(seq) {
	var countMoves = 0; /* 	post(m) */
	var seq = seq.replace(/\s*/, " ").replace(/^\s*/, "");
	seq = seq.split(" ");
	var parsedMoves = [];
	while (seq.length) {
		var thisMove = seq.shift();
		//post("\n\t\t", thisMove)
		if (thisMove.match(/^\d+\.0+$/)) continue;
		thisMove = thisMove.replace(/O/g, "0").replace(/^\d+\./, "").replace(/[^a-h0-8]/g, "");
		//post("\t\t.", thisMove)
		if (!(thisMove.match(/[a-h][1-8][a-h][1-8]/) || thisMove.match(/000?/))) continue;
		countMoves++;
		if (thisMove == "00") {
			if (countMoves % 2 == 1) thisMove = "e1g1";
			else thisMove = "e8g8";
		}
		if (thisMove == "000") {
			if (countMoves % 2 == 1) thisMove = "e1c1";
			else thisMove = "e8c8";
		}
		//post("\t\t", thisMove);
		parsedMoves.push(thisMove);
	}
	return parsedMoves;
}

function doNextMove() {
	outlet(0, "move", pMoves.shift());
}

function reset() {
	outlet(0, "reset");
	outlet(0, "flip", 0);
	outlet(1, "clear");
	pMoves = [];
	succesMoves = [];
}